<?php

/**
 * Implements hook_views_data_alter().
 */
function advanced_filter_views_data_alter(&$data) {
  $instances = field_info_instances();

  foreach ($instances as $instance) {
    foreach ($instance as $bundle) {
      foreach ($bundle as $field_name => $field) {
        if (in_array($field['widget']['module'], array('options', 'number', 'text'))) {
          $names[$field_name] = $field_name;
        }
      }
    }
  }

  if (!empty($names)) {
    foreach ($names as $field_name) {
      $table_name = "field_data_$field_name";

      foreach ($data[$table_name] as $id => $field) {
        if (isset($field['filter'])) {
          $data[$table_name][$id. '_adv'] = $field;
          $data[$table_name][$id. '_adv']['group'] = t('Advanced Filter');
          $data[$table_name][$id. '_adv']['filter']['handler'] = 'advanced_filter_views_handler_filter';
          unset($data[$table_name][$id. '_adv']['argument']);
          unset($data[$table_name][$id. '_adv']['sort']);
        }
      }
    }
  }
}