<?php

class advanced_filter_views_handler_filter extends views_handler_filter_in_operator {
  function init(&$view, &$options) {
    parent::init($view, $options);
    $this->no_operator = TRUE;
  }

  function has_extra_options() { return TRUE; }
  function operator_options() { return array(); }

  function option_definition() {
    $options = parent::option_definition();
    $options['filter'] = array('default' => '');
    return $options;
  }

  function extra_options_form(&$form, &$form_state) {
    parent::extra_options_form($form, $form_state);
    
    $form['filter'] = array(
      '#type' => 'textarea',
      '#title' => t('Filter'),
      '#default_value' => $this->options['filter'],
      '#rows' => 4,
      '#description' => t('See manual on !druit.', array('!druit' => l('Druit.ru', 'http://druit.ru', array('attributes' => array('target' => '_blank'))))),
    );
  }

  function get_value_options() {
    $this->value_options = $this->extract_values();
  }

  function extract_values($id = NULL) {
    $string = $this->options['filter'];
    $values = array();

    $list = explode("\n", $string);
    $list = array_map('trim', $list);
    $list = array_filter($list, 'strlen');

    foreach ($list as $position => $text) {
      $value = $key = FALSE;

      $matches = array();
      if (preg_match('/([a-z0-9_-]+)\|"(.*)"\|(.*)/i', $text, $matches)) {
        $key = $matches[1];
        $string = $matches[2];
        $value = $matches[3];
      }
      else {
        return array();
      }

      $values[$key] = $value;
      $strings[$key] = $string;
    }

    if (!empty($id)) {
      return $strings[$id];
    }
    else {
      return $values;
    }
  }

  function query() {
    if (empty($this->value)) {
      return;
    }
    
    $this->ensure_my_table();

    $key = $this->value[0];
    $snippet = $this->extract_values($key);
    $snippet = str_replace('#field#', "$this->table_alias.$this->real_field", $snippet);

    $this->query->add_where_expression($this->options['group'], $snippet);
  }
}